%define         version       16.04.1
# Bump when date/snapshot changes
%define         mainrel       1
%define         date          20170109
# Bump for rebuild of same snapshot
%define rel 7

%define         major         4
%define         major_gtk     4
%define         major_json    4

%define         gtk2          1
%{?_without_gtk3: %global gtk2 0}
%{?_with_gtk3: %global gtk2 1}

%define         gtk3          1
%{?_without_gtk3: %global gtk3 0}
%{?_with_gtk3: %global gtk3 1}

%define         libname       %mklibname dbusmenu-glib %{major}
%define         typelibname   %mklibname dbusmenu-gir 0.4
%define         jsonname      %mklibname dbusmenu-jsonloader %{major_json}
%define         develname     %mklibname dbusmenu-glib -d
%define         jsondevelname %mklibname dbusmenu-jsonloader -d
%define         toolsname     %{name}-tools

%if %{gtk2}
%define         gtk2dir       %{name}-%{version}+%{date}
%define         gtk2libname   %mklibname dbusmenu-gtk2_ %{major_gtk}
%define         typelibgtk2   %mklibname dbusmenu-gtk2-gir 0.4
%define         gtk2develname %mklibname dbusmenu-gtk2 -d
%endif

%if %{gtk3}
%define         gtk3dir       %{name}-gtk3-%{version}+%{date}
%define         gtk3libname   %mklibname dbusmenu-gtk3_ %{major_gtk}
%define         typelibgtk3   %mklibname dbusmenu-gtk3-gir 0.4
%define         gtk3develname %mklibname dbusmenu-gtk3 -d
%endif

Name:           libdbusmenu
Version:        %{version}
Release:        %mkrel %{mainrel}.%{date}.%{rel}
Summary:        Library for applications to pass a menu structure across DBus
License:        LGPLv3
Group:          System/Libraries
URL:            https://launchpad.net/dbusmenu
# Canonical doesn't understand the concept of releases, so get latest Ubuntu tarball: https://launchpad.net/ubuntu/+source/libdbusmenu
Source0:        %{name}-%{version}+%{date}.tar.xz

# patch to remove -Werror flag - fixes build despite usage of deprecated things
Patch0:         00-no-werror.patch

BuildRequires:  gnome-doc-utils
BuildRequires:  intltool
BuildRequires:  pkgconfig(atk)
BuildRequires:  pkgconfig(gio-2.0) >= 2.26
BuildRequires:  pkgconfig(gio-unix-2.0) >= 2.24
BuildRequires:  pkgconfig(glib-2.0) >= 2.26
BuildRequires:  pkgconfig(gobject-introspection-1.0) >= 0.10
BuildRequires:  pkgconfig(gtk+-2.0) >= 2.16
BuildRequires:  pkgconfig(gtk+-3.0) >= 2.91
BuildRequires:  pkgconfig(json-glib-1.0) >= 0.13.4
BuildRequires:  pkgconfig(valgrind)
BuildRequires:  pkgconfig(x11) >= 1.3
BuildRequires:  vala-tools
BuildRequires:  xsltproc

%description
A small little library that was created by pulling out some common code
out of indicator-applet. It passes a menu structure across DBus so that
a program can create a menu simply without worrying about how it is
displayed on the other side of the bus.

#-----------------------------------------------------------------------

%package -n     %{libname}
Summary:        Library for applications to pass a menu structure across DBus
Group:          System/Libraries

%description -n %{libname}
A small library for applications to raise "flags" on DBus for other
components of the desktop to pick up and visualize. Currently used by
the messaging indicator.

%files -n       %{libname}
%{_libdir}/%{name}-glib.so.%{major}{,.*}

#-----------------------------------------------------------------------

%package -n     %{typelibname}
Summary:        GObject introspection interface description for DBus
Group:          System/Libraries
Requires:       %{libname} = %{version}

%description -n %{typelibname}
A small library for applications to raise "flags" on DBus for other
components of the desktop to pick up and visualize. Currently used by
the messaging indicator.

%files -n       %{typelibname}
%{_libdir}/girepository-1.0/Dbusmenu-0.4.typelib

#-----------------------------------------------------------------------

%package -n     %{develname}
Summary:        Library headers for %{name}
Group:          Development/C
Requires:       %{libname} = %{version}
Requires:       %{typelibname} = %{version}
Provides:       %{name}-devel = %{version}-%{release}

%description -n %{develname}
This is the libraries, include files and other resources you can use
to incorporate %{name} into applications.

%files -n       %{develname}
%dir %{_includedir}/libdbusmenu-glib-0.4
%{_includedir}/libdbusmenu-glib-0.4/libdbusmenu-glib
%{_libdir}/libdbusmenu-glib.so
%{_libdir}/pkgconfig/dbusmenu-glib-0.4.pc
%{_datadir}/gir-1.0/Dbusmenu-0.4.gir
%{_datadir}/vala/vapi/Dbusmenu-0.4.vapi

%if %{gtk2}
#-----------------------------------------------------------------------

%package -n     %{gtk2libname}
Summary:        Library for applications to pass a menu structure across DBus
Group:          System/Libraries

%description -n %{gtk2libname}
A small little library that was created by pulling out some common code
out of indicator-applet. It passes a menu structure across DBus so that
a program can create a menu simply without worrying about how it is
displayed on the other side of the bus. Gtk+2 version.

%files -n       %{gtk2libname}
%{_libdir}/%{name}-gtk.so.%{major_gtk}{,.*}

#-----------------------------------------------------------------------

%package -n     %{typelibgtk2}
Summary:        GObject introspection interface description for DBusGtk
Group:          System/Libraries
Requires:       %{gtk2libname} = %{version}

%description -n %{typelibgtk2}
A small library for applications to raise "flags" on DBus for other
components of the desktop to pick up and visualize. Currently used by
the messaging indicator. Gtk+2 version

%files -n       %{typelibgtk2}
%{_libdir}/girepository-1.0/DbusmenuGtk-0.4.typelib

#------------------------------------------------------------------------

%package -n     %{gtk2develname}
Summary:        Library headers for %{name}
Group:          Development/C
Requires:       %{gtk2libname} = %{version}
Requires:       %{typelibgtk2} = %{version}
Requires:       %{develname} = %{version}
Provides:       %{name}-gtk-devel = %{version}-%{release}

%description -n %{gtk2develname}
This is the libraries, include files and other resources you can use
to incorporate %{name} into applications. Gtk+2 version

%files -n       %{gtk2develname}
%dir %{_includedir}/libdbusmenu-gtk-0.4
%{_includedir}/libdbusmenu-gtk-0.4/libdbusmenu-gtk
%{_libdir}/libdbusmenu-gtk.so
%{_libdir}/pkgconfig/dbusmenu-gtk-0.4.pc
%{_datadir}/gir-1.0/DbusmenuGtk-0.4.gir
%{_datadir}/vala/vapi/DbusmenuGtk-0.4.vapi

%endif
#-----------------------------------------------------------------------
%if %{gtk3}

%package -n     %{gtk3libname}
Summary:        Library for applications to pass a menu structure across DBus
Group:          System/Libraries

%description -n %{gtk3libname}
A small little library that was created by pulling out some common code
out of indicator-applet. It passes a menu structure across DBus so that
a program can create a menu simply without worrying about how it is
displayed on the other side of the bus.

%files -n       %{gtk3libname}
%{_libdir}/%{name}-gtk3.so.%{major_gtk}{,.*}

#-----------------------------------------------------------------------

%package -n     %{typelibgtk3}
Summary:        GObject introspection interface description for DBusGtk
Group:          System/Libraries
Requires:       %{gtk3libname} = %{version}

%description -n %{typelibgtk3}
A small library for applications to raise "flags" on DBus for other
components of the desktop to pick up and visualize. Currently used by
the messaging indicator.

%files -n       %{typelibgtk3}
%{_libdir}/girepository-1.0/DbusmenuGtk3-0.4.typelib

#-----------------------------------------------------------------------

%package -n     %{gtk3develname}
Summary:        Library headers for %{name}
Group:          Development/C
Requires:       %{gtk3libname} = %{version}
Requires:       %{typelibgtk3} = %{version}
Requires:       %{develname} = %{version}
Provides:       %{name}-gtk-devel = %{version}-%{release}

%description -n %{gtk3develname}
This is the libraries, include files and other resources you can use
to incorporate %{name} into applications.

%files -n       %{gtk3develname}
%dir %{_includedir}/libdbusmenu-gtk3-0.4
%{_includedir}/libdbusmenu-gtk3-0.4/libdbusmenu-gtk
%{_libdir}/libdbusmenu-gtk3.so
%{_libdir}/pkgconfig/dbusmenu-gtk3-0.4.pc
%{_datadir}/gir-1.0/DbusmenuGtk3-0.4.gir
%{_datadir}/vala/vapi/DbusmenuGtk3-0.4.vapi

#------------------------------------------------------------------------
%endif

%package -n     %{jsonname}
Summary:        Library for applications to pass a menu structure across DBus
Group:          System/Libraries

%description -n %{jsonname}
A small little library that was created by pulling out some common code
out of indicator-applet. It passes a menu structure across DBus so that
a program can create a menu simply without worrying about how it is
displayed on the other side of the bus.

%files -n       %{jsonname}
%{_libdir}/%{name}-jsonloader.so.%{major_json}{,.*}

#-----------------------------------------------------------------------

%package -n     %{jsondevelname}
Summary:        Library headers for %{name}
Group:          Development/C
Requires:       %{jsonname} = %{version}
Requires:       %{develname} = %{version}-%{release}
Provides:       %{name}-jsonloader-devel = %{version}-%{release}

%description -n %{jsondevelname}
This is the libraries, include files and other resources you can use
to incorporate %{name} into applications.

%files -n       %{jsondevelname}
%{_includedir}/libdbusmenu-glib-0.4/libdbusmenu-jsonloader
%{_libdir}/libdbusmenu-jsonloader.so
%{_libdir}/pkgconfig/dbusmenu-jsonloader-0.4.pc

#-----------------------------------------------------------------------

%package -n     %{toolsname}
Summary:        Tools useful when building applications
Group:          Development/C

%description -n %{toolsname}
This package contains tools that are useful when building applications.

%files -n       %{toolsname}
%doc %{_docdir}/%{name}/
%{_libexecdir}/dbusmenu-dumper
%{_libexecdir}/dbusmenu-testapp
%{_datadir}/%{name}/json/test-gtk-label.json

#-----------------------------------------------------------------------

%prep
%setup -c %{name}-%{version}+%{date}

pushd %{gtk2dir}
%autopatch -p1
popd

cp -a %{gtk2dir} %{gtk3dir}

%build
%if %{gtk2}
pushd %{gtk2dir}
./autogen.sh
%configure \
 --with-gtk=2 \
 --disable-static
%make_build
popd
%endif

%if %{gtk3}
pushd %{gtk3dir}
./autogen.sh
%configure \
 --with-gtk=3 \
 --disable-static
%make_build
popd
%endif


%install
%if %{gtk2}
%make_install -C %{gtk2dir}
%endif

%if %{gtk3}
%make_install -C %{gtk3dir}
%endif

find %{buildroot}%{_libdir} -name "*.la" -delete

# Remove benchmarking tool written in python2
rm %{buildroot}%{_libexecdir}/dbusmenu-bench


%changelog
* Sat Jun 28 2025 umeabot <umeabot> 16.04.1-1.20170109.7.mga10
+ Revision: 2218270
- Mageia 10 Mass Rebuild

* Thu May 04 2023 daviddavid <daviddavid> 16.04.1-1.20170109.6.mga9
+ Revision: 1955866
- fix owner of include dir

* Thu Mar 31 2022 umeabot <umeabot> 16.04.1-1.20170109.5.mga9
+ Revision: 1837631
- Mageia 9 Mass Rebuild

* Sun Feb 16 2020 umeabot <umeabot> 16.04.1-1.20170109.4.mga8
+ Revision: 1531418
- Mageia 8 Mass Rebuild
+ wally <wally>
- replace deprecated %%configure2_5x

* Fri Sep 13 2019 daviddavid <daviddavid> 16.04.1-1.20170109.3.mga8
+ Revision: 1440144
- remove -Werror flag to fix build despite usage of deprecated things
- remove benchmarking tool written in python2

* Sun Dec 02 2018 daviddavid <daviddavid> 16.04.1-1.20170109.2.mga7
+ Revision: 1337420
- Mageia 7 Mass Rebuild

* Sun Mar 12 2017 akien <akien> 16.04.1-1.20170109.1.mga7
+ Revision: 1092178
- Update to upstream 16.04.1+17.04.20170109.1 (yay for releases, Canonical!)

* Mon Feb 15 2016 umeabot <umeabot> 12.10.2-8.mga6
+ Revision: 960939
- Mageia 6 Mass Rebuild

* Fri Dec 18 2015 tarakbumba <tarakbumba> 12.10.2-7.mga6
+ Revision: 911771
- Bump rel

* Mon Dec 14 2015 tarakbumba <tarakbumba> 12.10.2-6.mga6
+ Revision: 910539
- Enable gtk2 build

* Wed Oct 15 2014 umeabot <umeabot> 12.10.2-5.mga5
+ Revision: 744411
- Second Mageia 5 Mass Rebuild

* Sun Sep 28 2014 tv <tv> 12.10.2-4.mga5
+ Revision: 731174
- rebuild so that it picks typelib() requires

* Tue Sep 16 2014 umeabot <umeabot> 12.10.2-3.mga5
+ Revision: 681401
- Mageia 5 Mass Rebuild

* Sat Oct 19 2013 umeabot <umeabot> 12.10.2-2.mga4
+ Revision: 530980
- Mageia 4 Mass Rebuild

* Wed Jul 31 2013 fwang <fwang> 12.10.2-1.mga4
+ Revision: 461436
- use patch to drop invalid flags
- drop Werror flags
- add more br
- new version 12.10.2

* Sat Jan 12 2013 umeabot <umeabot> 0.6.2-2.mga3
+ Revision: 356949
- Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

* Thu Jun 14 2012 fwang <fwang> 0.6.2-1.mga3
+ Revision: 260627
- update file list
- update file list
- br valgrind
- new version 0.6.2

* Thu Nov 03 2011 eatdirt <eatdirt> 0.5.1-1.mga2
+ Revision: 162155
- upgrade to 0.5.1

* Sun Jul 10 2011 fwang <fwang> 0.4.90-1.mga2
+ Revision: 121854
- update file list
- real gtk3 flavour
- update file list
- br gtk2 too
- gtk3 flavour
- new version 0.4.90
- enable introspection

* Sun Apr 03 2011 obgr_seneca <obgr_seneca> 0.4.1-1.mga1
+ Revision: 79979
- new version 0.4.1

* Thu Mar 24 2011 boklm <boklm> 0.3.16-3.mga1
+ Revision: 76164
- rebuild for bug #497

* Tue Mar 15 2011 obgr_seneca <obgr_seneca> 0.3.16-2.mga1
+ Revision: 71581
- removed some defines from the spec file
- replaced tabs ba spaces
- cleaned up spec file
- removed buildroot tag
- imported package libdbusmenu


* Fri Nov 05 2010 Funda Wang <fwang@mandriva.org> 0.3.16-1mdv2011.0
+ Revision: 593656
- new version 0.3.16
- disable gir building (it is failing)
- rebuild for new gir

* Sun Aug 01 2010 Funda Wang <fwang@mandriva.org> 0.3.8-2mdv2011.0
+ Revision: 564207
- rebuild
- drop unused patch
- New version 0.3.8

  + Emmanuel Andry <eandry@mandriva.org>
    - New version 0.2.9
    - BR vala-tools
    - update files list

* Sat Mar 13 2010 Nicolas Lécureuil <nlecureuil@mandriva.com> 0.2.6-1mdv2010.1
+ Revision: 518768
- Clean up of the spec file

  + John Balcaen <mikala@mandriva.org>
    - import libdbusmenu


